#include <bits/stdc++.h>
using namespace std;
int main()
{
	int n,c,q;
	scanf("%i%i%i",&n,&c,&q);
	string s;
	cin>>s;
	if(n==c)
	{
		int ctr1=0;
		for(int i=0;i<n;i++)
		{
			if(s[i]=='1')	ctr1++;
		}
		for(int i=1;i<=q;i++)
		{
			int a,b;
			scanf("%i%i",&a,&b);
			for(int i=a-1;i<b;i++)
			{
				if(s[i]=='0')
				{
					s[i]='1';
					ctr1++;
				}
				else if(s[i]=='1')
				{
					s[i]='0';
					ctr1--;
				}
			}
			printf("%i\n",ctr1);
		}
	}
	return 0;
}